# NOTE: Derived from blib/lib/ClearCase/Wrapper/DSB.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::DSB;

#line 397 "blib/lib/ClearCase/Wrapper/DSB.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/DSB/edattr.al)"
sub edattr {
    my %opt;
    GetOptions(\%opt, qw(element view));
    shift @ARGV;
    my $retstat = 0;
    my $editor = $ENV{WINEDITOR} || $ENV{VISUAL} || $ENV{EDITOR} ||
						    (MSWIN ? 'notepad' : 'vi');
    my $ct = ClearCase::Argv->new;
    my $ctq = $ct->clone({-stdout=>0, -stderr=>0});

    my $edtmp = ".$::prog.edattr.ed.$$";
    my $cstmp = ".$::prog.edattr.cs.$$";

    if ($opt{view}) {
	my($csum_pre, $csum_post) = (0, 0);
	my $tag = ViewTag(@ARGV);
	GetOptions(\%opt, qw(tag=s));
	Assert(@ARGV == 0);	# no file args allowed
	my @cs = $ct->catcs(['-tag', $tag])->qx;
	my @rest = grep !m%^##:\w+:%, @cs;
	my @attrs = map {m%^##:(\w+):\s*(\S*)%; "$1=$2\n"}
		    grep m%^##:(\w+):%, @cs;
	open(EDTMP, ">$edtmp") || die Msg('E', "$edtmp: $!");
	for (@attrs) {
	    $csum_pre += unpack("%16C*", $_);
	    print EDTMP $_;
	}
	close(EDTMP) || die Msg('E', "$edtmp: $!");
	Argv->new($editor, $edtmp)->system;
	open(EDTMP, $edtmp) || die Msg('E', "$edtmp: $!");
	my %nattrs;
	for (<EDTMP>) {
	    $csum_post += unpack("%16C*", $_);
	    chomp;
	    next if /(^\s*#|^\s*$)/;
	    my($attr, $val) = split(/=/, $_, 2);
	    $attr = ucfirst(lc($attr));
	    for ($attr, $val) {
		s%^\s+%%;
		s%\s+$%%;
	    }
	    $nattrs{$attr} = $val;
	}
	close(EDTMP) || die Msg('E', "$edtmp: $!");
	unlink $edtmp;
	# No need to reset the config spec if editor didn't change it.
	exit 0 if $csum_pre == $csum_post;
	open(CSTMP, ">$cstmp") || die Msg('E', "$cstmp: $!");
	for (sort keys %nattrs) {
	    printf CSTMP "%-10s %s\n", "##:$_:", $nattrs{$_};
	}
	print CSTMP @rest;
	close(CSTMP) || die Msg('E', "$cstmp: $!");
	$retstat = $ct->setcs(['-tag', $tag], $cstmp)->system;
	unlink $cstmp if !$retstat;
	exit $retstat;
    }

    Assert(@ARGV > 0);	# die with usage msg if untrue
    for my $obj (@ARGV) {
	my %indata = ();
	$obj .= '@@' if $opt{element};
	my @lines = $ct->desc([qw(-aattr -all)], $obj)->qx;
	if ($?) {
	    $retstat++;
	    next;
	}
	for my $line (@lines) {
	    next unless $line =~ /\s*(\S+)\s+=\s+(.+)/;
	    $indata{$1} = $2;
	}
	open(EDTMP, ">$edtmp") || die Msg('E', "$edtmp: $!");
	print EDTMP "# $obj (format: attr = \"val\"):\n\n" if !keys %indata;
	for (sort keys %indata) { print EDTMP "$_ = $indata{$_}\n" }
	close(EDTMP) || die Msg('E', "$edtmp: $!");

	# Run editor on temp file
	Argv->new($editor, $edtmp)->system;

	open(EDTMP, $edtmp) || die Msg('E', "$edtmp: $!");
	while (<EDTMP>) {
	    chomp;
	    next if /^\s*$|^\s*#.*$/;	# ignore null and comment lines
	    if (/\s*(\S+)\s+=\s+(.+)/) {
		my($attr, $newval) = ($1, $2);
		my $oldval;
		if (defined($oldval = $indata{$attr})) {
		    delete $indata{$attr};
		    # Skip if data unchanged.
		    next if $oldval eq $newval;
		}
		# Figure out what type the new attype needs to be.
		# Sorry, didn't bother with -vtype time.
		if ($ctq->lstype("attype:$attr")->system) {
		    if ($newval =~ /^".*"$/) {
			$ct->mkattype([qw(-nc -vty string)], $attr)->system;
		    } elsif ($newval =~ /^[+-]?\d+$/) {
			$ct->mkattype([qw(-nc -vty integer)], $attr)->system;
		    } elsif ($newval =~ /^-?\d+\.?\d*$/) {
			$ct->mkattype([qw(-nc -vty real)], $attr)->system;
		    } else {
			$ct->mkattype([qw(-nc -vty opaque)], $attr)->system;
		    }
		    next if $?;
		}
		# Deal with broken quoting on &^&@# Windows.
		if (MSWIN && $newval =~ /^"(.*)"$/) {
		    $newval = qq("\\"$1\\"");
		}
		# Make the new attr value.
		if (defined($oldval)) {
		    $retstat++ if $ct->mkattr([qw(-rep -c)],
			 "(Was: $oldval)", $attr, $newval, $obj)->system;
		} else {
		    $retstat++ if $ct->mkattr([qw(-rep)],
			 $attr, $newval, $obj)->system;
		}
	    } else {
		warn Msg('W', "incorrect line format: '$_'");
		$retstat++;
	    }
	}
	close(EDTMP) || die Msg('E', "$edtmp: $!");
	unlink $edtmp;

	# Now, delete any attrs that were deleted from the temp file.
	# First we do a simple rmattr; then see if it was the last of
	# its type and if so remove the type too.
	for (sort keys %indata) {
	    if ($ct->rmattr($_, $obj)->system) {
		$retstat++;
	    } else {
		# Don't remove the type if its vob serves as an admin vob!
		my @deps = grep /^<-/,
				$ct->desc([qw(-s -ahl AdminVOB)], 'vob:.')->qx;
		next if $? || @deps;
		$ct->rmtype(['-rmall'], "attype:$_")->system;
	    }
	}
    }
    exit $retstat;
}

# end of ClearCase::Wrapper::DSB::edattr
1;
