# NOTE: Derived from blib/lib/ClearCase/Wrapper/DSB.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package ClearCase::Wrapper::DSB;

#line 976 "blib/lib/ClearCase/Wrapper/DSB.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/DSB/setcs.al)"
sub setcs {
    my %opt;
    GetOptions(\%opt, qw(clone=s expand needed sync));
    die Msg('E', "-expand and -sync are mutually exclusive")
					    if $opt{expand} && $opt{sync};
    die Msg('E', "-expand and -needed are mutually exclusive")
					    if $opt{expand} && $opt{needed};
    my $tag = ViewTag(@ARGV) if grep /^(expand|sync|needed|clone)$/, keys %opt;
    if ($opt{expand}) {
	my $ct = Argv->new([$^X, '-S', $0]);
	my $settmp = ".$::prog.setcs.$$";
	open(EXP, ">$settmp") || die Msg('E', "$settmp: $!");
	print EXP $ct->opts(qw(catcs -expand -tag), $tag)->qx;
	close(EXP);
	$ct->opts('setcs', $settmp)->system;
	unlink $settmp;
	exit $?;
    } elsif ($opt{sync} || $opt{needed}) {
	chomp(my @srcs = qx($^X -S $0 catcs -sources -tag $tag));
	exit 2 if $?;
	(my $obj = $srcs[0]) =~ s/config_spec/.compiled_spec/;
	die Msg('E', "$obj: no such file") if ! -f $obj;
	die Msg('E', "no permission to update $tag's config spec") if ! -w $obj;
	my $otime = (stat $obj)[9];
	my $needed = grep { (stat $_)[9] > $otime } @srcs;
	if ($opt{sync}) {
	    if ($needed) {
		ClearCase::Argv->setcs(qw(-current -tag), $tag)->exec;
	    } else {
		exit 0;
	    }
	} else {
	    exit $needed;
	}
    } elsif ($opt{clone}) {
	my $ct = ClearCase::Argv->new;
	my $ctx = $ct->find_cleartool;
	my $cstmp = ".$ARGV[0].$$.cs.$tag";
	Argv->autofail(1);
	Argv->new("$ctx catcs -tag $opt{clone} > $cstmp")->system;
	$ct->setcs('-tag', $tag, $cstmp)->system;
	unlink($cstmp);
	exit 0;
    }
}

# end of ClearCase::Wrapper::DSB::setcs
1;
